﻿/*
 * Copyright (c) 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
namespace Tizen.Telephony
{
    /// <summary>
    /// This class contain the data related to the State changed event
    /// </summary>
    public class StateEventArgs : EventArgs
    {
        internal StateEventArgs(State s)
        {
            CurrentState = s;
        }

        /// <summary>
        /// The Current State
        /// </summary>
        public State CurrentState
        {
            get;
            internal set;
        }
    }
}
